Queued Operation
UnitAction is a record of an action to be performed by a Bridge Worker. They are queued and sent to the worker in creation order. If the worker is temporarily disconnected the queued actions will be sent when the worker reconnects or responds. If there are links between units applied or destroyed in a single API call, they will be sent to the appropriate worker(s) in the appropriate order (reverse or forword topological order). One or more UnitEvents will correspond to each UnitAction.
Operations
| Method | Endpoint | Description |
|---|---|---|
GET |
/bridge_worker/{bridge_worker_id}/queued_operation |
List QueuedOperations |
GET |
/unit_action |
List of UnitActions across units |
GET |
/bridge_worker/{bridge_worker_id}/queued_operation/{queued_operation_id} |
Get QueuedOperation |
List QueuedOperations
GET /bridge_worker/{bridge_worker_id}/queued_operation
List QueuedOperations
Operation ID: ListQueuedOperations
Parameters
Path Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
bridge_worker_id |
string | ✓ | Unique identifier for a bridge_worker_id |
Query Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
where |
string | The specified string is an expression for the purpose of filtering the list of QueuedOperations returned. The expression syntax was inspired by SQL. It supports conjunctions using AND of relational expressions of the form attribute operator attribute_or_literal. The attribute names are case-sensitive and PascalCase, as in the JSON encoding. Strings support the following operators: <, >, <=, >=, =, !=, LIKE, NOT LIKE, ILIKE, ~~, !~~, ~, ~*, !~, !~*, IN, NOT IN. String pattern operators: LIKE and ~~ for pattern matching with % and _ wildcards, ILIKE for case-insensitive pattern matching, NOT LIKE and !~~ for negated pattern matching. String regex operators: ~ for regex matching, ~* for case-insensitive regex, !~ and !~* for regex not matching (case-sensitive and insensitive). Integers support the following operators: <, >, <=, >=, =, !=, IN, NOT IN. UUIDs and boolean attributes support equality and inequality only. UUID and time literals must be quoted as string literals. String literals are quoted with single quotes, such as 'string'. Time literals use the same form as when serialized as JSON, such as: CreatedAt > '2025-02-18T23:16:34'. Integer and boolean literals are also supported for attributes of those types. Arrays support the ? operator to to match any element of the array, as in ApprovedBy ? '7c61626f-ddbe-41af-93f6-b69f4ab6d308'. Arrays can perform LEN() to check for length, as in LEN(ApprovedBy) > 0. Map support the dot notation to specify a particular map key, as in Labels.tier = 'Backend'. Maps support IS NULL and IS NOT NULL with dot notation to check for key absence or presence, as in Labels.tier IS NULL (key doesn't exist) or Labels.tier IS NOT NULL (key exists). Comparison results can be tested with IS TRUE, IS FALSE, IS NOT TRUE, and IS NOT FALSE. These are useful for nullable columns: MergeSourceID = '<uuid>' IS NOT FALSE matches rows where MergeSourceID equals the value OR is NULL. The IN and NOT IN operators accept a comma-separated list of values in parentheses, such as Slug IN ('slugone', 'slugtwo') or Labels.environment IN ('prod', 'staging'). Conjunctions are supported using the AND operator. An example conjunction is: CreatedAt >= '2025-01-07' AND Slug = 'test' AND Labels.mykey = 'myvalue'. Supported attributes for filtering on QueuedOperation: Action, BridgeWorkerID, CreatedAt, DriftReconciliationMode, DryRun, OrganizationID, QueuedOperationID, RevisionNum, SpaceID, Status, TargetID, UnitActionNum, UnitID. The whole string must be query-encoded. |
|
filter |
string | UUID of a Filter entity to apply to the QueuedOperation list. The Filter must be in the same Organization as the user credentials. The Filter's From field must match the entity type being filtered (QueuedOperation). For Space-resident entities, if the Filter has a FromSpaceID, it must match the operation's SpaceID. The Filter's Where clause will be combined with any explicit 'where' parameter using AND logic. If both 'filter' and 'where' parameters are specified, they are combined with AND logic. | |
contains |
string | Free text search that approximately matches the specified string against string fields and map keys/values. The search is case-insensitive and uses pattern matching to find entities containing the text. Searchable string fields include attributes like Slug, DisplayName, and string-typed custom fields. For map fields (like Labels and Annotations), the search matches both map keys and values. The search uses OR logic across all searchable fields, so matching any field will return the entity. If both 'where' and 'contains' parameters are specified, they are combined with AND logic. Searchable fields for QueuedOperation include string and map-type attributes from the queryable attributes list. The whole string must be query-encoded. |
Responses
| Status | Description | Content-Type | Schema |
|---|---|---|---|
| 200 | OK | application/json |
Array of QueuedOperation |
| 400 | QueuedOperation request is invalid (Bad Request). | application/json |
StandardErrorResponse |
| 401 | Unauthorized access. | application/json |
StandardErrorResponse |
| 403 | Forbidden access. | application/json |
StandardErrorResponse |
| 404 | QueuedOperation not found. | application/json |
StandardErrorResponse |
| 500 | Something went wrong while processing QueuedOperation. | application/json |
StandardErrorResponse |
| default | Unexpected error. | application/json |
StandardErrorResponse |
List of UnitActions across units
GET /unit_action
Retrieves a list of UnitActions across units in the Organization, returning at most one UnitAction per unit
Operation ID: ListAllUnitActions
Parameters
Query Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
where |
string | The specified string is an expression for the purpose of filtering the list of QueuedOperations returned. The expression syntax was inspired by SQL. It supports conjunctions using AND of relational expressions of the form attribute operator attribute_or_literal. The attribute names are case-sensitive and PascalCase, as in the JSON encoding. Strings support the following operators: <, >, <=, >=, =, !=, LIKE, NOT LIKE, ILIKE, ~~, !~~, ~, ~*, !~, !~*, IN, NOT IN. String pattern operators: LIKE and ~~ for pattern matching with % and _ wildcards, ILIKE for case-insensitive pattern matching, NOT LIKE and !~~ for negated pattern matching. String regex operators: ~ for regex matching, ~* for case-insensitive regex, !~ and !~* for regex not matching (case-sensitive and insensitive). Integers support the following operators: <, >, <=, >=, =, !=, IN, NOT IN. UUIDs and boolean attributes support equality and inequality only. UUID and time literals must be quoted as string literals. String literals are quoted with single quotes, such as 'string'. Time literals use the same form as when serialized as JSON, such as: CreatedAt > '2025-02-18T23:16:34'. Integer and boolean literals are also supported for attributes of those types. Arrays support the ? operator to to match any element of the array, as in ApprovedBy ? '7c61626f-ddbe-41af-93f6-b69f4ab6d308'. Arrays can perform LEN() to check for length, as in LEN(ApprovedBy) > 0. Map support the dot notation to specify a particular map key, as in Labels.tier = 'Backend'. Maps support IS NULL and IS NOT NULL with dot notation to check for key absence or presence, as in Labels.tier IS NULL (key doesn't exist) or Labels.tier IS NOT NULL (key exists). Comparison results can be tested with IS TRUE, IS FALSE, IS NOT TRUE, and IS NOT FALSE. These are useful for nullable columns: MergeSourceID = '<uuid>' IS NOT FALSE matches rows where MergeSourceID equals the value OR is NULL. The IN and NOT IN operators accept a comma-separated list of values in parentheses, such as Slug IN ('slugone', 'slugtwo') or Labels.environment IN ('prod', 'staging'). Conjunctions are supported using the AND operator. An example conjunction is: CreatedAt >= '2025-01-07' AND Slug = 'test' AND Labels.mykey = 'myvalue'. Supported attributes for filtering on QueuedOperation: Action, BridgeWorkerID, CreatedAt, DriftReconciliationMode, DryRun, OrganizationID, QueuedOperationID, RevisionNum, SpaceID, Status, TargetID, UnitActionNum, UnitID. The whole string must be query-encoded. |
|
filter |
string | UUID of a Filter entity to apply to the QueuedOperation list. The Filter must be in the same Organization as the user credentials. The Filter's From field must match the entity type being filtered (QueuedOperation). For Space-resident entities, if the Filter has a FromSpaceID, it must match the operation's SpaceID. The Filter's Where clause will be combined with any explicit 'where' parameter using AND logic. If both 'filter' and 'where' parameters are specified, they are combined with AND logic. | |
contains |
string | Free text search that approximately matches the specified string against string fields and map keys/values. The search is case-insensitive and uses pattern matching to find entities containing the text. Searchable string fields include attributes like Slug, DisplayName, and string-typed custom fields. For map fields (like Labels and Annotations), the search matches both map keys and values. The search uses OR logic across all searchable fields, so matching any field will return the entity. If both 'where' and 'contains' parameters are specified, they are combined with AND logic. Searchable fields for QueuedOperation include string and map-type attributes from the queryable attributes list. The whole string must be query-encoded. |
Responses
| Status | Description | Content-Type | Schema |
|---|---|---|---|
| 200 | OK | application/json |
Array of UnitAction |
| 400 | QueuedOperation request is invalid (Bad Request). | application/json |
StandardErrorResponse |
| 401 | Unauthorized access. | application/json |
StandardErrorResponse |
| 403 | Forbidden access. | application/json |
StandardErrorResponse |
| 404 | QueuedOperation not found. | application/json |
StandardErrorResponse |
| 500 | Something went wrong while processing QueuedOperation. | application/json |
StandardErrorResponse |
| default | Unexpected error. | application/json |
StandardErrorResponse |
Get QueuedOperation
GET /bridge_worker/{bridge_worker_id}/queued_operation/{queued_operation_id}
Get QueuedOperation
Operation ID: GetQueuedOperation
Parameters
Path Parameters
| Parameter | Type | Required | Description |
|---|---|---|---|
bridge_worker_id |
string | ✓ | Unique identifier for a bridge_worker_id |
queued_operation_id |
string | ✓ | Unique identifier for a queued_operation_id |
Responses
| Status | Description | Content-Type | Schema |
|---|---|---|---|
| 200 | UnitAction is a record of an action to be performed by a Bridge Worker. They are queued and sent to the worker in creation order. If the worker is temporarily disconnected the queued actions will be sent when the worker reconnects or responds. If there are links between units applied or destroyed in a single API call, they will be sent to the appropriate worker(s) in the appropriate order (reverse or forword topological order). One or more UnitEvents will correspond to each UnitAction. | application/json |
QueuedOperation |
| 400 | QueuedOperation request is invalid (Bad Request). | application/json |
StandardErrorResponse |
| 401 | Unauthorized access. | application/json |
StandardErrorResponse |
| 403 | Forbidden access. | application/json |
StandardErrorResponse |
| 404 | QueuedOperation not found. | application/json |
StandardErrorResponse |
| 500 | Something went wrong while processing QueuedOperation. | application/json |
StandardErrorResponse |
| default | Unexpected error. | application/json |
StandardErrorResponse |
Schemas
QueuedOperation
UnitAction is a record of an action to be performed by a Bridge Worker. They are queued and sent to the worker in creation order. If the worker is temporarily disconnected the queued actions will be sent when the worker reconnects or responds. If there are links between units applied or destroyed in a single API call, they will be sent to the appropriate worker(s) in the appropriate order (reverse or forword topological order). One or more UnitEvents will correspond to each UnitAction.
Properties
| Property | Type | Required | Description |
|---|---|---|---|
Action |
ActionType |
||
BridgeState |
string (base64) | ||
BridgeWorkerID |
string (uuid) | BridgeWorkerID is the unique identifier of the bridge worker that will process this operation. | |
CreatedAt |
string (date-time) | The timestamp when the entity was created in "2023-01-01T12:00:00Z" format. | |
Data |
string (base64) | The result of a dry-run Data-changing action like refresh and import, where the data is not stored in the Unit. | |
Dependencies |
Array of UUID |
Dependencies contains the list of operation IDs that this operation depends on. Operations will not be delivered until all dependencies are completed. | |
DriftReconciliationMode |
string | The drift reconciliation mode for the unit at the time of the operation. | |
DryRun |
boolean | DryRun indicates whether the action is a dry run. | |
ErrorDetails |
Array of ErrorItem |
Error details returned by the worker. | |
ExtraParams |
string | ExtraParams contains additional parameters for the operation in string format. | |
LiveData |
string (base64) | ||
LiveState |
string (base64) | ||
OrganizationID |
string (uuid) | OrganizationID is the unique identifier of the organization this operation belongs to. | |
QueuedOperationID |
string (uuid) | QueuedOperationID is the unique identifier for the queued unit action. | |
RevisionNum |
integer (int64) | RevisionNum is the revision number this operation was performed on. | |
SpaceID |
string (uuid) | SpaceID is the unique identifier of the space of the unit this operation is performed on. | |
Status |
string | Status indicates the current status of the unit action. v2 statuses: Initializing (being set up), Pending (waiting), Delivered (sent to worker), Progressing (being processed), Completed (success), Failed (error). v1 compatibility: 'pending' = Pending, 'delivered' = Completed (legacy 'delivered' meant work done). | |
TargetID |
string (uuid) | TargetID is the unique identifier of the target this operation is directed to. | |
UnitActionNum |
integer (int64) | UnitActionNum is the sequence number of this unit action. | |
UnitID |
string (uuid) | UnitID is the unique identifier of the unit this operation is performed on. | |
UserAgent |
string | User-Agent string of the API call. | |
UserID |
string (uuid) | UserID of the user the action was performed by. | |
UserIsBot |
boolean | Whether the user who requested the action is a bot user. | |
UserRole |
string | Organization-level role of the user who requested the action. | |
Version |
integer (int64) | An entity-specific sequence number used for optimistic concurrency control. The value read must be sent in calls to Update. |
StandardErrorResponse
Error response details.
Properties
| Property | Type | Required | Description |
|---|---|---|---|
Code |
string | HTTP status code of the response. | |
Message |
string | Message returned with the response. |
UnitAction
UnitAction is a record of an action to be performed by a Bridge Worker. They are queued and sent to the worker in creation order. If the worker is temporarily disconnected the queued actions will be sent when the worker reconnects or responds. If there are links between units applied or destroyed in a single API call, they will be sent to the appropriate worker(s) in the appropriate order (reverse or forword topological order). One or more UnitEvents will correspond to each UnitAction.
Properties
| Property | Type | Required | Description |
|---|---|---|---|
Action |
ActionType |
||
BridgeState |
string (base64) | ||
BridgeWorkerID |
string (uuid) | BridgeWorkerID is the unique identifier of the bridge worker that will process this operation. | |
CreatedAt |
string (date-time) | The timestamp when the entity was created in "2023-01-01T12:00:00Z" format. | |
Data |
string (base64) | The result of a dry-run Data-changing action like refresh and import, where the data is not stored in the Unit. | |
Dependencies |
Array of UUID |
Dependencies contains the list of operation IDs that this operation depends on. Operations will not be delivered until all dependencies are completed. | |
DriftReconciliationMode |
string | The drift reconciliation mode for the unit at the time of the operation. | |
DryRun |
boolean | DryRun indicates whether the action is a dry run. | |
ErrorDetails |
Array of ErrorItem |
Error details returned by the worker. | |
ExtraParams |
string | ExtraParams contains additional parameters for the operation in string format. | |
LiveData |
string (base64) | ||
LiveState |
string (base64) | ||
OrganizationID |
string (uuid) | OrganizationID is the unique identifier of the organization this operation belongs to. | |
QueuedOperationID |
string (uuid) | QueuedOperationID is the unique identifier for the queued unit action. | |
RevisionNum |
integer (int64) | RevisionNum is the revision number this operation was performed on. | |
SpaceID |
string (uuid) | SpaceID is the unique identifier of the space of the unit this operation is performed on. | |
Status |
string | Status indicates the current status of the unit action. v2 statuses: Initializing (being set up), Pending (waiting), Delivered (sent to worker), Progressing (being processed), Completed (success), Failed (error). v1 compatibility: 'pending' = Pending, 'delivered' = Completed (legacy 'delivered' meant work done). | |
TargetID |
string (uuid) | TargetID is the unique identifier of the target this operation is directed to. | |
UnitActionNum |
integer (int64) | UnitActionNum is the sequence number of this unit action. | |
UnitID |
string (uuid) | UnitID is the unique identifier of the unit this operation is performed on. | |
UserAgent |
string | User-Agent string of the API call. | |
UserID |
string (uuid) | UserID of the user the action was performed by. | |
UserIsBot |
boolean | Whether the user who requested the action is a bot user. | |
UserRole |
string | Organization-level role of the user who requested the action. | |
Version |
integer (int64) | An entity-specific sequence number used for optimistic concurrency control. The value read must be sent in calls to Update. |